package com.ippon.pouet.common.domain.error;

public class MissingMandatoryValueException extends PouetException {

  protected MissingMandatoryValueException(PouetExceptionBuilder builder) {
    super(builder);
  }

  public static MissingMandatoryValueException forNullValue(String fieldName) {
    return new MissingMandatoryValueException(
      builder(StandardMessage.SERVER_MANDATORY_NULL, fieldName, defaultMessage(fieldName) + " (null)")
    );
  }

  public static MissingMandatoryValueException forBlankValue(String fieldName) {
    return new MissingMandatoryValueException(
      builder(StandardMessage.SERVER_MANDATORY_BLANK, fieldName, defaultMessage(fieldName) + " (blank)")
    );
  }

  private static PouetExceptionBuilder builder(PouetMessage pouetMessage, String fieldName, String message) {
    return PouetException.builder(pouetMessage).status(ErrorStatus.INTERNAL_SERVER_ERROR).argument("field", fieldName).message(message);
  }

  private static String defaultMessage(String fieldName) {
    return "The field \"" + fieldName + "\" is mandatory and wasn't set";
  }
}
